/*******************************************************************************
 * FoxProjectile_DartBase generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxProjectile_DartBase extends FoxProjectile_GrenadeBase
    config(Projectile)
    hidecategories(Navigation);

var AkEvent StartLoopEvent;
var AkEvent StopLoopEvent;
var protected export editinline LensFlareComponent LensFlareComp;
var bool bExplodeOnStick;
var float KillMomentumScalar;
var Vector StartingLocation;
var Vector OriginalInstigatorPosition;
var const float InstigatorMoveToPickupSizeSq;

simulated event PostBeginPlay()
{
    super.PostBeginPlay();
    TurnOnFlare();
    //return;    
}

simulated function Explode(Vector HitLocation, Vector HitNormal)
{
    TurnOffFlare();
    super.Explode(HitLocation, HitNormal);
    //return;    
}

simulated function TurnOnFlare()
{
    // End:0x27
    if(StartLoopEvent != none)
    {
        PlayAkEvent(StartLoopEvent, true);
    }
    LensFlareComp.SetIsActive(true);
    //return;    
}

simulated function TurnOffFlare()
{
    // End:0x27
    if(StopLoopEvent != none)
    {
        PlayAkEvent(StopLoopEvent, true);
    }
    LensFlareComp.SetIsActive(false);
    //return;    
}

simulated event Destroyed()
{
    TurnOffFlare();
    Mesh.DetachFromAny();
    super.Destroyed();
    //return;    
}

simulated function Init(Vector Direction)
{
    super.Init(Direction);
    StartingLocation = Location;
    //return;    
}

simulated function HandleStickTo(StickToDetails NewStickToInfo)
{
    // End:0xDC
    if(((Role == ROLE_Authority) && FoxPawn(NewStickToInfo.StickToActor) != none) && KillMomentumScalar != float(0))
    {
        FoxPawn(NewStickToInfo.StickToActor).TakeDamageStartLoc = StartingLocation;
        FoxPawn(NewStickToInfo.StickToActor).TakeDamageMomentumMultiplier = KillMomentumScalar;
    }
    // End:0x171
    if((FoxPawn(NewStickToInfo.StickToActor) != none) && FoxPawn(NewStickToInfo.StickToActor).IsLocallyControlled())
    {
        LensFlareComp.SetIsActive(false);
        StopTrailEmitterComponent();
    }
    super.HandleStickTo(NewStickToInfo);
    // End:0x19B
    if(bExplodeOnStick)
    {
        DoExplosion();
    }
    // End:0x22F
    if(((Role == ROLE_Authority) && GrenadeTimerLength == float(0)) && (FoxPawn(NewStickToInfo.StickToActor) == none) || FoxPawn_HardSuit(NewStickToInfo.StickToActor) != none)
    {
        SetRemovalTimer(DestructionTimer);
    }
    //return;    
}

function DelayCanBePickedup()
{
    // End:0x65
    if(bCanPickup && Instigator != none)
    {
        bCanPickup = false;
        OriginalInstigatorPosition = Instigator.Location;
        SetTimer(0.250, true, 'CheckInstigatorPosition');
    }
    //return;    
}

function CheckInstigatorPosition()
{
    // End:0x6B
    if(Instigator != none)
    {
        // End:0x68
        if(VSizeSq(Instigator.Location - OriginalInstigatorPosition) > InstigatorMoveToPickupSizeSq)
        {
            bCanPickup = true;
            ClearTimer('CheckInstigatorPosition');
        }
    }
    // End:0x7F
    else
    {
        ClearTimer('CheckInstigatorPosition');
    }
    //return;    
}

defaultproperties
{
    begin object name=LFC0 class=LensFlareComponent
        bAutoActivate=false
        NextTraceTime=-0.35236670
        ReplacementPrimitive=none
    object end
    // Reference: LensFlareComponent'Default__FoxProjectile_DartBase.LFC0'
    LensFlareComp=LFC0
    InstigatorMoveToPickupSizeSq=100.0
    begin object name=StaticMeshComponent0 class=StaticMeshComponent
        ReplacementPrimitive=none
    object end
    // Reference: StaticMeshComponent'Default__FoxProjectile_DartBase.StaticMeshComponent0'
    Mesh=StaticMeshComponent0
    IndirectTimerLength=6.0
    ProjLightEnvironment=DynamicLightEnvironmentComponent'Default__FoxProjectile_DartBase.MyLightEnvironment'
    begin object name=CollisionCylinder class=CylinderComponent
        ReplacementPrimitive=none
    object end
    // Reference: CylinderComponent'Default__FoxProjectile_DartBase.CollisionCylinder'
    CylinderComponent=CollisionCylinder
    begin object name=CollisionCylinder class=CylinderComponent
        ReplacementPrimitive=none
    object end
    // Reference: CylinderComponent'Default__FoxProjectile_DartBase.CollisionCylinder'
    Components(0)=CollisionCylinder
    Components(1)=DynamicLightEnvironmentComponent'Default__FoxProjectile_DartBase.MyLightEnvironment'
    begin object name=StaticMeshComponent0 class=StaticMeshComponent
        ReplacementPrimitive=none
    object end
    // Reference: StaticMeshComponent'Default__FoxProjectile_DartBase.StaticMeshComponent0'
    Components(2)=StaticMeshComponent0
    begin object name=LFC0 class=LensFlareComponent
        bAutoActivate=false
        NextTraceTime=-0.35236670
        ReplacementPrimitive=none
    object end
    // Reference: LensFlareComponent'Default__FoxProjectile_DartBase.LFC0'
    Components(3)=LFC0
    begin object name=CollisionCylinder class=CylinderComponent
        ReplacementPrimitive=none
    object end
    // Reference: CylinderComponent'Default__FoxProjectile_DartBase.CollisionCylinder'
    CollisionComponent=CollisionCylinder
}